/* coreography, a tool for examining ELF based memory images.
 * Copyright (C) 2003  John Ventura ventura@engination.com
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * This file contains the necessary data for processing commands given
 * at the commaand line.
 */
#include <stdio.h>

#define CMD_NULL	0
#define CMD_STRINGS	1
#define CMD_SEGDUMP	2
#define CMD_REGDUMP	3
#define CMD_ARGDUMP	4
#define CMD_INFO	5
#define CMD_FRAME	6
#define CMD_SEARCH	7

struct cmdentry {
    int value;
    char *cmdname;
};

#if MAIN
struct cmdentry cmdtab[] = {
    {CMD_STRINGS, "strings"},	/* similar to strings(1) */
    {CMD_SEGDUMP, "segdump"},	/* view contents of a segment */
    {CMD_SEGDUMP, "secdump"},	/* alias too segdump */
    {CMD_REGDUMP, "regdump"},	/* view "user" registers  */
    {CMD_INFO, "info"},		/* parse all header info */
    {CMD_ARGDUMP, "argdump"},	/* show command line */
    {CMD_FRAME, "frame"},	/* trace the frame */
    {CMD_SEARCH, "search"},	/* look for a something */
    {CMD_NULL, NULL}
};
#endif

#define MASK_NULL				0x00
#define MASK_ALL				0x00
#define MASK_AUXILIARY				0x01
#define MASK_MMAP				0x02
#define MASK_TEXT				0x04
#define MASK_HEAP				0x08
#define MASK_LIBS				0x10
#define MASK_STACK				0x20


struct segmententry {
    int value;
    char *name;
};

#if MAIN
struct segmententry segmenttab[] = {
    {MASK_AUXILIARY, "aux"},	/* auxiliary segment */
    {MASK_TEXT, "text"},	/* everything 8048000 and up */
    {MASK_MMAP, "mmap"},	/* everything 4000000 and up */
    {MASK_STACK, "stack"},	/* everything bffe000 and up */
    {MASK_ALL, "all"},		/* everything */
    {MASK_NULL, NULL}
};
#endif
