/* coreography, a tool for examining ELF based memory images.
 * Copyright (C) 2003  John Ventura ventura@engination.com
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* This file contains definitions that are used for the display information
 * in the "info" command.  A lot of it was cribbed from elf.h
 */

/* The definitions in elf.h are not as consistant between machines, as 
 * one might think.  The rest of this file tries to deal with that
 */

#ifndef EM_NONE
#define	EM_NONE	0
#endif
#ifndef EM_M32
#define	EM_M32	1
#endif
#ifndef EM_SPARC
#define	EM_SPARC	2
#endif
#ifndef EM_386
#define	EM_386	3
#endif
#ifndef EM_68K
#define	EM_68K	4
#endif
#ifndef EM_88K
#define	EM_88K	5
#endif
#ifndef EM_860
#define	EM_860	7
#endif
#ifndef EM_MIPS
#define	EM_MIPS	8
#endif
#ifndef EM_S370
#define	EM_S370	9
#endif
#ifndef EM_MIPS_RS3_LE
#define	EM_MIPS_RS3_LE	10
#endif
#ifndef EM_PARISC
#define	EM_PARISC	15
#endif
#ifndef EM_VPP500
#define	EM_VPP500	17
#endif
#ifndef EM_SPARC32PLUS
#define	EM_SPARC32PLUS	18
#endif
#ifndef EM_960
#define	EM_960	19
#endif
#ifndef EM_PPC
#define	EM_PPC	20
#endif
#ifndef EM_PPC64
#define	EM_PPC64	21
#endif
#ifndef EM_S390
#define	EM_S390	22
#endif
#ifndef EM_V800
#define	EM_V800	36
#endif
#ifndef EM_FR20
#define	EM_FR20	37
#endif
#ifndef EM_RH32
#define	EM_RH32	38
#endif
#ifndef EM_RCE
#define	EM_RCE	39
#endif
#ifndef EM_ARM
#define	EM_ARM	40
#endif
#ifndef EM_FAKE_ALPHA
#define	EM_FAKE_ALPHA	41
#endif
#ifndef EM_SH
#define	EM_SH	42
#endif
#ifndef EM_SPARCV9
#define	EM_SPARCV9	43
#endif
#ifndef EM_TRICORE
#define	EM_TRICORE	44
#endif
#ifndef EM_ARC
#define	EM_ARC	45
#endif
#ifndef EM_H8_300
#define	EM_H8_300	46
#endif
#ifndef EM_H8_300H
#define	EM_H8_300H	47
#endif
#ifndef EM_H8S
#define	EM_H8S	48
#endif
#ifndef EM_H8_500
#define	EM_H8_500	49
#endif
#ifndef EM_IA_64
#define	EM_IA_64	50
#endif
#ifndef EM_MIPS_X
#define	EM_MIPS_X	51
#endif
#ifndef EM_COLDFIRE
#define	EM_COLDFIRE	52
#endif
#ifndef EM_68HC12
#define	EM_68HC12	53
#endif
#ifndef EM_MMA
#define	EM_MMA	54
#endif
#ifndef EM_PCP
#define	EM_PCP	55
#endif
#ifndef EM_NCPU
#define	EM_NCPU	56
#endif
#ifndef EM_NDR1
#define	EM_NDR1	57
#endif
#ifndef EM_STARCORE
#define	EM_STARCORE	58
#endif
#ifndef EM_ME16
#define	EM_ME16	59
#endif
#ifndef EM_ST100
#define	EM_ST100	60
#endif
#ifndef EM_TINYJ
#define	EM_TINYJ	61
#endif
#ifndef EM_X86_64
#define	EM_X86_64	62
#endif
#ifndef EM_PDSP
#define	EM_PDSP	63
#endif
#ifndef EM_FX66
#define	EM_FX66	66
#endif
#ifndef EM_ST9PLUS
#define	EM_ST9PLUS	67
#endif
#ifndef EM_ST7
#define	EM_ST7	68
#endif
#ifndef EM_68HC16
#define	EM_68HC16	69
#endif
#ifndef EM_68HC11
#define	EM_68HC11	70
#endif
#ifndef EM_68HC08
#define	EM_68HC08	71
#endif
#ifndef EM_68HC05
#define	EM_68HC05	72
#endif
#ifndef EM_SVX
#define	EM_SVX	73
#endif
#ifndef EM_AT19
#define	EM_AT19	74
#endif
#ifndef EM_VAX
#define	EM_VAX	75
#endif
#ifndef EM_CRIS
#define	EM_CRIS	76
#endif
#ifndef EM_JAVELIN
#define	EM_JAVELIN	77
#endif
#ifndef EM_FIREPATH
#define	EM_FIREPATH	78
#endif
#ifndef EM_ZSP
#define	EM_ZSP	79
#endif
#ifndef EM_MMIX
#define	EM_MMIX	80
#endif
#ifndef EM_HUANY
#define	EM_HUANY	81
#endif
#ifndef EM_PRISM
#define	EM_PRISM	82
#endif
#ifndef EM_AVR
#define	EM_AVR	83
#endif
#ifndef EM_FR30
#define	EM_FR30	84
#endif
#ifndef EM_D10V
#define	EM_D10V	85
#endif
#ifndef EM_D30V
#define	EM_D30V	86
#endif
#ifndef EM_V850
#define	EM_V850	87
#endif
#ifndef EM_M32R
#define	EM_M32R	88
#endif
#ifndef EM_MN10300
#define	EM_MN10300	89
#endif
#ifndef EM_MN10200
#define	EM_MN10200	90
#endif
#ifndef EM_PJ
#define	EM_PJ	91
#endif
#ifndef EM_OPENRISC
#define	EM_OPENRISC	92
#endif
#ifndef EM_ARC_A5
#define	EM_ARC_A5	93
#endif
#ifndef EM_XTENSA
#define	EM_XTENSA	94
#endif
#ifndef EM_NUM
#define	EM_NUM	95
#endif
#ifndef EM_Z500
#define	EM_Z500	99
#endif
#ifndef EM_ALPHA
#define	EM_ALPHA	0x9026
#endif
#ifndef SHT_NULL
#define	SHT_NULL	0
#endif
#ifndef SHT_PROGBITS
#define	SHT_PROGBITS	1
#endif
#ifndef SHT_SYMTAB
#define	SHT_SYMTAB	2	/* Symbol table */
#endif
#ifndef SHT_STRTAB
#define	SHT_STRTAB	3	/* String table */
#endif
#ifndef SHT_RELA
#define	SHT_RELA	4	/* Relocation entries with addends */
#endif
#ifndef SHT_HASH
#define	SHT_HASH	5	/* Symbol hash table */
#endif
#ifndef SHT_DYNAMIC
#define	SHT_DYNAMIC	6	/* Dynamic linking information */
#endif
#ifndef SHT_NOTE
#define	SHT_NOTE	7	/* Notes */
#endif
#ifndef SHT_NOBITS
#define	SHT_NOBITS	8	/* Program space with no */
#endif
#ifndef SHT_REL
#define	SHT_REL	9		/* Relocation entries, no addends */
#endif
#ifndef SHT_SHLIB
#define	SHT_SHLIB	10	/* Reserved */
#endif
#ifndef SHT_DYNSYM
#define	SHT_DYNSYM	11	/* Dynamic linker symbol table */
#endif
#ifndef SHT_INIT_ARRAY
#define	SHT_INIT_ARRAY	14	/* Array of constructors */
#endif
#ifndef SHT_FINI_ARRAY
#define	SHT_FINI_ARRAY	15	/* Array of destructors */
#endif
#ifndef SHT_PREINIT_ARRAY
#define	SHT_PREINIT_ARRAY	16	/* Array of pre-constructors */
#endif
#ifndef SHT_GROUP
#define	SHT_GROUP	17	/* Section group */
#endif
#ifndef SHT_SYMTAB_SHNDX
#define	SHT_SYMTAB_SHNDX	18	/* Extended section indeces */
#endif
#ifndef SHT_NUM
#define	SHT_NUM	19		/* Number of defined types.  */
#endif
#ifndef SHT_LOOS
#define	SHT_LOOS	0x60000000	/* Start OS-specific */
#endif
#ifndef SHT_GNU_LIBLIST
#define	SHT_GNU_LIBLIST	0x6ffffff7	/* Prelink library list */
#endif
#ifndef SHT_CHECKSUM
#define	SHT_CHECKSUM	0x6ffffff8	/* Checksum for DSO content. */
#endif
#ifndef SHT_LOSUNW
#define	SHT_LOSUNW	0x6ffffffa	/* Sun-specific low bound. */
#endif
#ifndef SHT_SUNW_move
#define	SHT_SUNW_move	0x6ffffffa
#endif
#ifndef SHT_SUNW_COMDAT
#define	SHT_SUNW_COMDAT	0x6ffffffb
#endif
#ifndef SHT_SUNW_syminfo
#define	SHT_SUNW_syminfo	0x6ffffffc
#endif
#ifndef SHT_GNU_verdef
#define	SHT_GNU_verdef	0x6ffffffd
#endif
#ifndef SHT_GNU_verneed
#define	SHT_GNU_verneed	0x6ffffffe
#endif
#ifndef SHT_GNU_versym
#define	SHT_GNU_versym	0x6fffffff
#endif
#ifndef SHT_HISUNW
#define	SHT_HISUNW	0x6fffffff
#endif
#ifndef SHT_HIOS
#define	SHT_HIOS	0x6fffffff
#endif
#ifndef SHT_LOPROC
#define	SHT_LOPROC	0x70000000
#endif
#ifndef SHT_HIPROC
#define	SHT_HIPROC	0x7fffffff
#endif
#ifndef SHT_LOUSER
#define	SHT_LOUSER	0x80000000
#endif
#ifndef SHT_HIUSER
#define	SHT_HIUSER	0x8fffffff
#endif
#ifndef SHF_INFO_LINK
#define	SHF_INFO_LINK	(1 << 6)
#endif
#ifndef SHT_MIPS_LIBLIST
#define	SHT_MIPS_LIBLIST	0x70000000
#endif
#ifndef SHT_MIPS_MSYM
#define	SHT_MIPS_MSYM	0x70000001
#endif
#ifndef SHT_MIPS_CONFLICT
#define	SHT_MIPS_CONFLICT	0x70000002
#endif
#ifndef SHT_MIPS_GPTAB
#define	SHT_MIPS_GPTAB	0x70000003
#endif
#ifndef SHT_MIPS_UCODE
#define	SHT_MIPS_UCODE	0x70000004
#endif
#ifndef SHT_MIPS_DEBUG
#define	SHT_MIPS_DEBUG	0x70000005
#endif
#ifndef SHT_MIPS_REGINFO
#define	SHT_MIPS_REGINFO	0x70000006
#endif
#ifndef SHT_MIPS_PACKAGE
#define	SHT_MIPS_PACKAGE	0x70000007
#endif
#ifndef SHT_MIPS_PACKSYM
#define	SHT_MIPS_PACKSYM	0x70000008
#endif
#ifndef SHT_MIPS_RELD
#define	SHT_MIPS_RELD	0x70000009
#endif
#ifndef SHT_MIPS_IFACE
#define	SHT_MIPS_IFACE	0x7000000b
#endif
#ifndef SHT_MIPS_CONTENT
#define	SHT_MIPS_CONTENT	0x7000000c
#endif
#ifndef SHT_MIPS_OPTIONS
#define	SHT_MIPS_OPTIONS	0x7000000d
#endif
#ifndef SHT_MIPS_SHDR
#define	SHT_MIPS_SHDR	0x70000010
#endif
#ifndef SHT_MIPS_FDESC
#define	SHT_MIPS_FDESC	0x70000011
#endif
#ifndef SHT_MIPS_EXTSYM
#define	SHT_MIPS_EXTSYM	0x70000012
#endif
#ifndef SHT_MIPS_DENSE
#define	SHT_MIPS_DENSE	0x70000013
#endif
#ifndef SHT_MIPS_PDESC
#define	SHT_MIPS_PDESC	0x70000014
#endif
#ifndef SHT_MIPS_LOCSYM
#define	SHT_MIPS_LOCSYM	0x70000015
#endif
#ifndef SHT_MIPS_AUXSYM
#define	SHT_MIPS_AUXSYM	0x70000016
#endif
#ifndef SHT_MIPS_OPTSYM
#define	SHT_MIPS_OPTSYM	0x70000017
#endif
#ifndef SHT_MIPS_LOCSTR
#define	SHT_MIPS_LOCSTR	0x70000018
#endif
#ifndef SHT_MIPS_LINE
#define	SHT_MIPS_LINE	0x70000019
#endif
#ifndef SHT_MIPS_RFDESC
#define	SHT_MIPS_RFDESC	0x7000001a
#endif
#ifndef SHT_MIPS_DELTASYM
#define	SHT_MIPS_DELTASYM	0x7000001b
#endif
#ifndef SHT_MIPS_DELTAINST
#define	SHT_MIPS_DELTAINST	0x7000001c
#endif
#ifndef SHT_MIPS_DELTACLASS
#define	SHT_MIPS_DELTACLASS	0x7000001d
#endif
#ifndef SHT_MIPS_DWARF
#define	SHT_MIPS_DWARF	0x7000001e
#endif
#ifndef SHT_MIPS_DELTADECL
#define	SHT_MIPS_DELTADECL	0x7000001f
#endif
#ifndef SHT_MIPS_SYMBOL_LIB
#define	SHT_MIPS_SYMBOL_LIB	0x70000020
#endif
#ifndef SHT_MIPS_EVENTS
#define	SHT_MIPS_EVENTS	0x70000021
#endif
#ifndef SHT_MIPS_TRANSLATE
#define	SHT_MIPS_TRANSLATE	0x70000022
#endif
#ifndef SHT_MIPS_PIXIE
#define	SHT_MIPS_PIXIE	0x70000023
#endif
#ifndef SHT_MIPS_XLATE
#define	SHT_MIPS_XLATE	0x70000024
#endif
#ifndef SHT_MIPS_XLATE_DEBUG
#define	SHT_MIPS_XLATE_DEBUG	0x70000025
#endif
#ifndef SHT_MIPS_WHIRL
#define	SHT_MIPS_WHIRL	0x70000026
#endif
#ifndef SHT_MIPS_EH_REGION
#define	SHT_MIPS_EH_REGION	0x70000027
#endif
#ifndef SHT_MIPS_XLATE_OLD
#define	SHT_MIPS_XLATE_OLD	0x70000028
#endif
#ifndef SHT_MIPS_PDR_EXCEPTION
#define	SHT_MIPS_PDR_EXCEPTION	0x70000029
#endif
#ifndef SHT_PARISC_EXT
#define	SHT_PARISC_EXT	0x70000000
#endif
#ifndef SHT_PARISC_UNWIND
#define	SHT_PARISC_UNWIND	0x70000001
#endif
#ifndef SHT_PARISC_DOC
#define	SHT_PARISC_DOC	0x70000002
#endif
#ifndef SHT_ALPHA_DEBUG
#define	SHT_ALPHA_DEBUG	0x70000001
#endif
#ifndef SHT_ALPHA_REGINFO
#define	SHT_ALPHA_REGINFO	0x70000002
#endif
#ifndef SHT_IA_64_EXT
#define	SHT_IA_64_EXT	(SHT_LOPROC + 0)
#endif
#ifndef SHT_IA_64_UNWIND
#define	SHT_IA_64_UNWIND	(SHT_LOPROC + 1)
#endif
#ifndef PT_NULL
#define	PT_NULL	0		/* Program header table entry */
#endif
#ifndef PT_LOAD
#define	PT_LOAD	1		/* Loadable program segment */
#endif
#ifndef PT_DYNAMIC
#define	PT_DYNAMIC	2	/* Dynamic linking information */
#endif
#ifndef PT_INTERP
#define	PT_INTERP	3	/* Program interpreter */
#endif
#ifndef PT_NOTE
#define	PT_NOTE	4		/* Auxiliary information */
#endif
#ifndef PT_SHLIB
#define	PT_SHLIB	5	/* Reserved */
#endif
#ifndef PT_PHDR
#define	PT_PHDR	6		/* Entry for header table */
#endif
#ifndef PT_TLS
#define	PT_TLS	7		/* Thread-local storage segment */
#endif
#ifndef PT_NUM
#define	PT_NUM	8		/* Number of defined types */
#endif
#ifndef PT_LOOS
#define	PT_LOOS	0x60000000	/* Start of OS-specific */
#endif
#ifndef PT_GNU_EH_FRAME
#define	PT_GNU_EH_FRAME	0x6474e550	/* GCC .eh_frame_hdr segment */
#endif
#ifndef PT_LOSUNW
#define	PT_LOSUNW	0x6ffffffa
#endif
#ifndef PT_SUNWBSS
#define	PT_SUNWBSS	0x6ffffffa	/* Sun Specific segment */
#endif
#ifndef PT_SUNWSTACK
#define	PT_SUNWSTACK	0x6ffffffb	/* Stack segment */
#endif
#ifndef PT_HISUNW
#define	PT_HISUNW	0x6fffffff
#endif
#ifndef PT_HIOS
#define	PT_HIOS	0x6fffffff	/* End of OS-specific */
#endif
#ifndef PT_LOPROC
#define	PT_LOPROC	0x70000000	/* Start of processor-specific */
#endif
#ifndef PT_HIPROC
#define	PT_HIPROC	0x7fffffff	/* End of processor-specific */
#endif
#ifndef PT_MIPS_REGINFO
#define	PT_MIPS_REGINFO	0x70000000	/* Register usage information */
#endif
#ifndef PT_MIPS_RTPROC
#define	PT_MIPS_RTPROC	0x70000001	/* Runtime procedure table. */
#endif
#ifndef PT_MIPS_OPTIONS
#define	PT_MIPS_OPTIONS	0x70000002
#endif
#ifndef PT_HP_TLS
#define	PT_HP_TLS	(PT_LOOS + 0x0)
#endif
#ifndef PT_HP_CORE_NONE
#define	PT_HP_CORE_NONE	(PT_LOOS + 0x1)
#endif
#ifndef PT_HP_CORE_VERSION
#define	PT_HP_CORE_VERSION	(PT_LOOS + 0x2)
#endif
#ifndef PT_HP_CORE_KERNEL
#define	PT_HP_CORE_KERNEL	(PT_LOOS + 0x3)
#endif
#ifndef PT_HP_CORE_COMM
#define	PT_HP_CORE_COMM	(PT_LOOS + 0x4)
#endif
#ifndef PT_HP_CORE_PROC
#define	PT_HP_CORE_PROC	(PT_LOOS + 0x5)
#endif
#ifndef PT_HP_CORE_LOADABLE
#define	PT_HP_CORE_LOADABLE	(PT_LOOS + 0x6)
#endif
#ifndef PT_HP_CORE_STACK
#define	PT_HP_CORE_STACK	(PT_LOOS + 0x7)
#endif
#ifndef PT_HP_CORE_SHM
#define	PT_HP_CORE_SHM	(PT_LOOS + 0x8)
#endif
#ifndef PT_HP_CORE_MMF
#define	PT_HP_CORE_MMF	(PT_LOOS + 0x9)
#endif
#ifndef PT_HP_PARALLEL
#define	PT_HP_PARALLEL	(PT_LOOS + 0x10)
#endif
#ifndef PT_HP_FASTBIND
#define	PT_HP_FASTBIND	(PT_LOOS + 0x11)
#endif
#ifndef PT_HP_OPT_ANNOT
#define	PT_HP_OPT_ANNOT	(PT_LOOS + 0x12)
#endif
#ifndef PT_HP_HSL_ANNOT
#define	PT_HP_HSL_ANNOT	(PT_LOOS + 0x13)
#endif
#ifndef PT_HP_STACK
#define	PT_HP_STACK	(PT_LOOS + 0x14)
#endif
#ifndef PT_PARISC_ARCHEXT
#define	PT_PARISC_ARCHEXT	0x70000000
#endif
#ifndef PT_PARISC_UNWIND
#define	PT_PARISC_UNWIND	0x70000001
#endif
#ifndef PT_IA_64_ARCHEXT
#define	PT_IA_64_ARCHEXT	(PT_LOPROC + 0)	/* arch extension */
#endif
#ifndef PT_IA_64_UNWIND
#define	PT_IA_64_UNWIND	(PT_LOPROC + 1)	/* ia64 unwind */
#endif


struct e_machine {
    Elf32_Word value;
    char *str;
};

struct e_type {
    Elf32_Word value;
    char *str;
};

struct p_type {
    Elf32_Word value;
    char *tagstr;
    char *description;
};

struct sh_type {
    Elf32_Word value;
    char *tagstr;
    char *description;
};

struct e_type etype[] = {
    {ET_REL, "Relocatable file"},
    {ET_EXEC, "Executable file"},
    {ET_DYN, "Shared object file"},
    {ET_CORE, "Core File"},
    {ET_NUM, "Number of defined types"},
    {ET_NONE, "no file type"},
};



struct e_machine emachine[] = {
    {EM_M32, "AT&T WE 32100 "},
    {EM_SPARC, "SUN SPARC "},
    {EM_386, "Intel 80386 "},
    {EM_68K, "Motorola m68k family "},
    {EM_88K, "Motorola m88k family "},
    {EM_860, "Intel 80860 "},
    {EM_MIPS, "MIPS R3000 big-endian "},
    {EM_S370, "IBM System370 "},
    {EM_MIPS_RS3_LE, "MIPS R3000 little-endian "},
    {EM_PARISC, "HPPA "},
    {EM_VPP500, "Fujitsu VPP500 "},
    {EM_SPARC32PLUS, "Sun's \"v8plus\" "},
    {EM_960, "Intel 80960 "},
    {EM_PPC, "PowerPC "},
    {EM_PPC64, "PowerPC 64-bit "},
    {EM_S390, "IBM S390 "},
    {EM_V800, "NEC V800 series "},
    {EM_FR20, "Fujitsu FR20 "},
    {EM_RH32, "TRW RH-32 "},
    {EM_RCE, "Motorola RCE "},
    {EM_ARM, "ARM "},
    {EM_FAKE_ALPHA, "Digital Alpha "},
    {EM_SH, "Hitachi SH "},
    {EM_SPARCV9, "SPARC v9 64-bit "},
    {EM_TRICORE, "Siemens Tricore "},
    {EM_ARC, "Argonaut RISC Core "},
    {EM_H8_300, "Hitachi H8300 "},
    {EM_H8_300H, "Hitachi H8300H "},
    {EM_H8S, "Hitachi H8S "},
    {EM_H8_500, "Hitachi H8500 "},
    {EM_IA_64, "Intel Merced "},
    {EM_MIPS_X, "Stanford MIPS-X "},
    {EM_COLDFIRE, "Motorola Coldfire "},
    {EM_68HC12, "Motorola M68HC12 "},
    {EM_MMA, "Fujitsu MMA Multimedia Accelerator"},
    {EM_PCP, "Siemens PCP "},
    {EM_NCPU, "Sony nCPU embeeded RISC "},
    {EM_NDR1, "Denso NDR1 microprocessor "},
    {EM_STARCORE, "Motorola Start Core processor"},
    {EM_ME16, "Toyota ME16 processor "},
    {EM_ST100, "STMicroelectronic ST100 processor "},
    {EM_TINYJ, "Advanced Logic Corp. Tinyj emb.fam"},
    {EM_X86_64, "AMD x86-64 architecture "},
    {EM_PDSP, "Sony DSP Processor "},
    {EM_FX66, "Siemens FX66 microcontroller "},
    {EM_ST9PLUS, "STMicroelectronics ST9+ 816 mc "},
    {EM_ST7, "STmicroelectronics ST7 8 bit mc "},
    {EM_68HC16, "Motorola MC68HC16 microcontroller "},
    {EM_68HC11, "Motorola MC68HC11 microcontroller "},
    {EM_68HC08, "Motorola MC68HC08 microcontroller "},
    {EM_68HC05, "Motorola MC68HC05 microcontroller "},
    {EM_SVX, "Silicon Graphics SVx "},
    {EM_AT19, "STMicroelectronics ST19 8 bit mc "},
    {EM_VAX, "Digital VAX "},
    {EM_CRIS, "Axis Communications 32-bit embedded processor "},
    {EM_JAVELIN, "Infineon Technologies 32-bit embedded processor "},
    {EM_FIREPATH, "Element 14 64-bit DSP Processor "},
    {EM_ZSP, "LSI Logic 16-bit DSP Processor "},
    {EM_MMIX, "Donald Knuth's educational 64-bit processor "},
    {EM_HUANY, "Harvard University machine-independent object files "},
    {EM_PRISM, "SiTera Prism "},
    {EM_AVR, "Atmel AVR 8-bit microcontroller "},
    {EM_FR30, "Fujitsu FR30 "},
    {EM_D10V, "Mitsubishi D10V "},
    {EM_D30V, "Mitsubishi D30V "},
    {EM_V850, "NEC v850 "},
    {EM_M32R, "Mitsubishi M32R "},
    {EM_MN10300, "Matsushita MN10300 "},
    {EM_MN10200, "Matsushita MN10200 "},
    {EM_PJ, "picoJava "},
    {EM_OPENRISC, "OpenRISC 32-bit embedded processor "},
    {EM_ARC_A5, "ARC Cores Tangent-A5 "},
    {EM_XTENSA, "Tensilica Xtensa Architecture "},
    {EM_ALPHA, "ALPHA"},
    {EM_NONE, "No machine "},
};

struct p_type ptype[] = {
    {PT_NULL, "PT_NULL", "NULL"},
    {PT_LOAD, "PT_LOAD", "Loadable program segment"},
    {PT_DYNAMIC, "PT_DYNAMIC", "Dynamic linking information"},
    {PT_INTERP, "PT_INTERP", "Program interpreter"},
    {PT_NOTE, "PT_NOTE", "Auxiliary information"},
    {PT_SHLIB, "PT_SHLIB", "Reserved"},
    {PT_PHDR, "PT_PHDR", "Entry for header table itself"},
    {PT_TLS, "PT_TLS", "Thread-local storage segment"},
    {PT_NUM, "PT_NUM", "Number of defined types"},
    {PT_LOOS, "PT_LOOS", "Start of OS-specific"},
    {PT_GNU_EH_FRAME, "PT_GNU_EH_FRAME", "GCC .eh_frame_hdr segment"},
    {PT_LOSUNW, "PT_LOSUNW", "LOSUNW"},
    {PT_SUNWBSS, "PT_SUNWBSS", "Sun Specific segment"},
    {PT_SUNWSTACK, "PT_SUNWSTACK", "Stack segment"},
    {PT_HISUNW, "PT_HISUNW", "HISUNW"},
    {PT_HIOS, "PT_HIOS", "End of OS-specific"},
    {PT_LOPROC, "PT_LOPROC", "Start of processor-specific"},
    {PT_HIPROC, "PT_HIPROC", "End of processor-specific"},
};

struct sh_type shtype[] = {
    {SHT_NULL, "SHT_NULL", "Section header table entry unused"},
    {SHT_PROGBITS, "SHT_PROGBITS", "Program data"},
    {SHT_SYMTAB, "SHT_SYMTAB", "Symbol table"},
    {SHT_STRTAB, "SHT_STRTAB", "String table"},
    {SHT_RELA, "SHT_RELA", "Relocation entries with addends"},
    {SHT_HASH, "SHT_HASH", "Symbol hash table"},
    {SHT_DYNAMIC, "SHT_DYNAMIC", "Dynamic linking information"},
    {SHT_NOTE, "SHT_NOTE", "Notes"},
    {SHT_NOBITS, "SHT_NOBITS", "Program space with no data (bss)"},
    {SHT_REL, "SHT_REL", "Relocation entries, no addends"},
    {SHT_SHLIB, "SHT_SHLIB", "Reserved"},
    {SHT_DYNSYM, "SHT_DYNSYM", "Dynamic linker symbol table"},
    {SHT_INIT_ARRAY, "SHT_INITARRAY", "Array of constructors"},
    {SHT_FINI_ARRAY, "SHT_FINIARRAY", "Array of destructors"},
    {SHT_PREINIT_ARRAY, "SHT_PREINITARRAY", "Array of pre-constructors"},
    {SHT_GROUP, "SHT_GROUP", "Section group"},
    {SHT_SYMTAB_SHNDX, "SHT_SYMTAB_SHNDX", "Extended section indeces"},
    {SHT_NUM, "SHT_NUM", "Number of defined types."},
    {SHT_LOOS, "SHT_LOOS", "Start OS-specific"},
    {SHT_GNU_LIBLIST, "SHT_GNU_LIBLIST", "Prelink library list"},
    {SHT_CHECKSUM, "SHT_CHECKSUM", "Checksum for DSO content."},
    {SHT_LOSUNW, "SHT_LOSUNW", "Sun-specific low bound."},
    {SHT_SUNW_move, "SHT_SUNW_move", ""},
    {SHT_SUNW_COMDAT, "SHT_SUNW_COMDAT", ""},
    {SHT_SUNW_syminfo, "SHT_SUNW_syminfo", ""},
    {SHT_GNU_verdef, "SHT_GNU_verdef", "Version definition section."},
    {SHT_GNU_verneed, "SHT_GNU_verneed", "Version needs section."},
    {SHT_GNU_versym, "SHT_GNU_versym", "Version symbol table."},
    {SHT_LOPROC, "SHT_LOPROC", "Start of processor-specific"},
    {SHT_HIPROC, "SHT_HIPROC", "End of processor-specific"},
    {SHT_LOUSER, "SHT_LOUSER", "Start of application-specific"},
    {SHT_HIUSER, "SHT_HIUSER", "End of application-specific"}
};

