/* coreography, a tool for examining ELF based memory images.
 * Copyright (C) 2003  John Ventura ventura@engination.com
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#include <elf.h>
#include <sys/types.h>

/* This function will return a pointer to the type specified by type.
 * buf is a pointer to the begining of the auxiliary segment in a core
 * dump, and len is the length of that dump.
 * NULL is returned if that structure isn't found.
 */

void *getauxinfo(uint8_t * buf, int len, int type)
{
    int note_offset;
    Elf32_Nhdr *note;

    for (note_offset = 0; note_offset <= len;
	 note_offset +=
	 (sizeof(Elf32_Nhdr) + note->n_namesz + note->n_descsz)) {
	note = (Elf32_Nhdr *) (buf + note_offset);
	if (note->n_type == type) {
	    return (buf + note_offset + note->n_namesz +
		    sizeof(Elf32_Nhdr));
	}
    }
    return (NULL);
}
