/* coreography, a tool for examining ELF based memory images.
 * Copyright (C) 2003  John Ventura ventura@engination.com
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <unistd.h>

/* it's a search function.
 * buf is the needle
 * query is they haystack
 * len is the length of buf
 * querylen is the length of query
 * address is the virtual addresss of the segment we are searching
 */

int search(uint8_t * buf, int len, uint32_t address, uint8_t * query,
	   int querylen, FILE * desc)
{
    int rval = 0;
    int i;
    if (query == NULL) {
	fprintf(stderr, "Please specify a query string\n");
	fprintf(stderr, "-a specifies an ascii string to search for\n");
	fprintf(stderr,
		"-x specifies a sequence of bytes to search for\n");
	fprintf(stderr, "\t(must be expressed in hexidecimal)\n");
	exit(1);
    }
    for (i = 0; i < (len - querylen); i++) {
	if (!memcmp(query, &buf[i], querylen)) {
	    rval++;
	    fprintf(desc, "%08x\n", address);
	}
	address++;
    }
    return (rval);
}
