/* coreography, a tool for examining ELF based memory images.
 * Copyright (C) 2003  John Ventura ventura@engination.com
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#define SIGHUP		 1
#define SIGINT		 2
#define SIGQUIT		 3
#define SIGILL		 4
#define SIGTRAP		 5
#define SIGABRT		 6
#define SIGIOT		 6
#define SIGBUS		 7
#define SIGFPE		 8
#define SIGKILL		 9
#define SIGUSR1		10
#define SIGSEGV		11
#define SIGUSR2		12
#define SIGPIPE		13
#define SIGALRM		14
#define SIGTERM		15
#define SIGSTKFLT	16
#define SIGCHLD		17
#define SIGCONT		18
#define SIGSTOP		19
#define SIGTSTP		20
#define SIGTTIN		21
#define SIGTTOU		22
#define SIGURG		23
#define SIGXCPU		24
#define SIGXFSZ		25
#define SIGVTALRM	26
#define SIGPROF		27
#define SIGWINCH	28
#define SIGIO		29
#define SIGPOLL		SIGIO
#define SIGLOST		29
#define SIGPWR		30
#define SIGSYS		31
#define SIGRTMIN	32



struct sigentry {
    int signal;
    char *signame;
    char *description;
};

struct sigentry sigtab[] = {
    {SIGHUP, "SIGHUP", "Hangup (POSIX)"},
    {SIGINT, "SIGINT", "Interrupt (ANSI)"},
    {SIGQUIT, "SIGQUIT", "Quit (POSIX)"},
    {SIGILL, "SIGILL", "Illegal instruction (ANSI)"},
    {SIGTRAP, "SIGTRAP", "Trace trap (POSIX)"},
    {SIGABRT, "SIGABRT", "Abort (ANSI)"},
    {SIGIOT, "SIGIOT", "IOT trap (4.2 BSD)"},
    {SIGBUS, "SIGBUS", "BUS error (4.2 BSD)"},
    {SIGFPE, "SIGFPE", "Floating-point exception (ANSI)"},
    {SIGKILL, "SIGKILL", "Kill, unblockable (POSIX)"},
    {SIGUSR1, "SIGUSR1", "User-defined signal 1 (POSIX)"},
    {SIGSEGV, "SIGSEGV", "Segmentation violation (ANSI)"},
    {SIGUSR2, "SIGUSR2", "User-defined signal 2 (POSIX)"},
    {SIGPIPE, "SIGPIPE", "Broken pipe (POSIX)"},
    {SIGALRM, "SIGALRM", "Alarm clock (POSIX)"},
    {SIGTERM, "SIGTERM", "Termination (ANSI)"},
    {SIGSTKFLT, "SIGSTKFLT", "Stack fault"},
    {SIGCHLD, "SIGCHLD", "Child status has changed (POSIX)"},
    {SIGCONT, "SIGCONT", "Continue (POSIX)"},
    {SIGSTOP, "SIGSTOP", "Stop, unblockable (POSIX)"},
    {SIGTSTP, "SIGTSTP", "Keyboard stop (POSIX)"},
    {SIGTTIN, "SIGTTIN", "Background read from tty (POSIX)"},
    {SIGTTOU, "SIGTTOU", "Background write to tty (POSIX)"},
    {SIGURG, "SIGURG", "Urgent condition on socket (4.2 BSD)"},
    {SIGXCPU, "SIGXCPU", "CPU limit exceeded (4.2 BSD)"},
    {SIGXFSZ, "SIGXFSZ", "File size limit exceeded (4.2 BSD)"},
    {SIGVTALRM, "SIGVTALRM", "Virtual alarm clock (4.2 BSD)"},
    {SIGPROF, "SIGPROF", "Profiling alarm clock (4.2 BSD)"},
    {SIGWINCH, "SIGWINCH", "Window size change (4.3 BSD, Sun)"},
    {SIGIO, "SIGIO", "I/O now possible (4.2 BSD)"},
    {SIGPWR, "SIGPWR", "Power failure restart (System V)"},
    {SIGSYS, "SIGSYS", "Bad system call"},
};
